import java.awt.*;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Vector;
import java.lang.Thread;
import java.awt.event.KeyEvent;

/**
*
* Canvas recevant dans lequel s'execute le jeu
*
* Cette classe procure un off graphic ainsi que le moteur permettant de grer
* le jeu.
* Elle gre un listener recevant les informations comme
* - Collision notable avec un lment du dcors
* - Collision notable avec un sprite
*
* @author C Caissotti
*
*/

public class GameCanvas3 extends Canvas implements Runnable
{
    Graphics gOff = null;
    Graphics gScreen = null;
    Image imgOff = null;
    protected Thread t = null;
//    public GameThread tref = null;
    protected int wait = 25;
    Dimension last = null;
    protected GameListener gl = null;
    protected Vector keys;
    boolean painted;
    public boolean play = false;
    public int idle;
   //
    // Extends this methode
    //
    private int tuid = 0; // Permet d'avoir un id
    private int tid = -1; // Id de la thread en cours

//    protected class GameThread extends Thread
//    {
   // Variables utilises par la thread();
     long l;
     long l2;
     long lw = 0;
     int np = 0;
     int nw = 0;
     private int lid; // Id local de la thread

    public void run()
    {
     System.out.println("ArcadeVillage GameThread 200501-1");
     while ( t != null )
      {
       if ( tid == -1 )
         {
          Thread.yield();
          try
           {
             Thread.sleep(300);  // Sinon, on a passer trop de temps, on attend pas
            }
           catch( Exception e ){}
          continue;
         }
       lid = tid;
       while ( lid == tid  )
        {
         l = System.currentTimeMillis();
         onTip();
         idle++;
       try
         {
          if ( painted )
            {
             np++;
             painted=false;
             repaint();
            }
          else
            {
             nw++;
            }
           l2 = System.currentTimeMillis();
           lw = l2-l;
           lw = wait - lw;
           if ( lw > 0 )
             {
              if ( lw < 18 ) lw = 18;
              try
              {
               Thread.sleep(lw);  // Sinon, on a passer trop de temps, on attend pas
              }
              catch( Exception e ){}
             }
         }
         catch( Exception e )
         {
          System.out.println("Game canvas thread error "+e);
          return;
         }
        }
       System.out.println("np="+String.valueOf(np)+",nw="+String.valueOf(nw));
      }
    }
//}

    //
    // Constructor
    //
    public GameCanvas3()
    {
        keys = new Vector(10);
        last=null;
        painted=true;
    }

    /**
    *
    * set the Game listener
    * @param l a Game listener
    *
    */

    public void setGameListener( GameListener l )
    {
        this.gl = l;
    }

    /**
    *
    * get the score listener
    * @return the actual score listener
    *
    */
    public GameListener getGameListener( )
    {
        return this.gl;
    }
    /**
    *
    * set the image provider
    * @param a ImgProvider object
    *
    */

    public void stopThread()
    {
     tid = -1;
     t = null;
    }

    //
    // Thread management
    //
    public synchronized void setWait( int w )
    {
        wait = w;
    }


    public synchronized void setPlay( boolean b )
    {
     if ( play == b ) return;
     play = b;
     if ( play )
       {
        idle = 0;
        tid = tuid++;
       if ( t == null )
          {
           t = new Thread(this);
           t.start();
          }
        painted=true;
       }
     else
       {
        tid = -1;
       }
    }

    //
    // Modify this function to implement the thread action
    //
    protected void onTip()
    {
    }


  public void paint( Graphics g )
    {
        if ( imgOff == null || last == null )
        {
            last = getSize();
            imgOff = createImage( last.width, last.height );
            gOff = imgOff.getGraphics();
            gScreen = g;
            if ( gOff == null ) return; // Pas encore prt
        }
      update(g);
    }

    public void update( Graphics g )
     {
      if ( g == null || imgOff == null || last == null ) return;
      drawOff();
      g.drawImage(imgOff, 0, 0, this );
      painted=true;
     }



/*    synchronized boolean getPainted()
    {
      return painted;
    }
    synchronized void setPainted( boolean b )
    {
      painted = b;
    }*/
    //
    // Extends this class to draw the off screen
    //
    public void drawOff()
    {
    }


    //
    //
    //
    protected void addKey( KeyEvent e )
    {
        keys.addElement( e );
    }

    protected KeyEvent getKey()
    {
        try
        {
        KeyEvent e = null;
        if ( !keys.isEmpty() )
           {
            e = ( KeyEvent )keys.elementAt(0);
            keys.removeElementAt(0);
           }
        return e;
        }
        catch( Exception e )
        {
            return null;
        }

    }

    public void flushKeys()
    {
        keys.removeAllElements();
    }


}