import java.awt.image.*;
import java.util.*;
import java.awt.*;

/**
*
*
* An object of this class load an image from the disk
* The position of each character is given after
*
* @author C.Caissotti
* @see ImgProvider
*
*/

public class OneImgProvider implements ImgProvider
{
    private Hashtable t = new Hashtable(50);
    private Image gi = null; // Contain the global image loaded
    public Dimension is; // Size of the image
    private Component c; // A component
 
    public boolean load( Component c, Image img )
    {
     try
      {
       this.c = c;
       MediaTracker mt = new MediaTracker(c);
       gi = img;
       mt.addImage(gi, 0);
       mt.waitForAll();
       if ( mt.isErrorAny() ) return false;
       is = new Dimension( gi.getWidth(null), gi.getHeight(null) );
       return true;
      }
     catch( Exception e )
      {
       System.out.println("OneImgProvider.load : "+e);
       return false;
      }
    }
    
    /**
    *
    * This function must be called after the call of load
    * because the images of each element are created here
    *
    * @param name, the name
    * @param rn the rectangle containing the sub-image
    * @return true if the definition has been added
    *
    */
    
    public boolean addDefinition( String name, Rectangle r )
    {
     Image img;
     if ( gi == null ) return false;
     if ( r.x + r.width > is.width || r.y + r.height > is.height ) return false;
     int  pixels[] = new int[ r.width * r.height ]; 
	   PixelGrabber pg = new PixelGrabber(gi, r.x, r.y, r.width, r.height, pixels, 0, r.width );
	    try {
       	    pg.grabPixels();
	        } 
	    catch (InterruptedException ex)
	        {
	        System.err.println("Pixel grabber "+ex);
	        return false;
	        }
     img = c.createImage( new MemoryImageSource( r.width, r.height, ColorModel.getRGBdefault(), pixels, 0, r.width ));
     t.put(name.toLowerCase(), img);
     return true;
    }
    
    /**
    *
    * Return an image wich has the given name
    *
    * @see ImgProvider
    *
    */
    
    public Image getImage( String name )
    {
        return ( Image )t.get(name.toLowerCase());
    }
        
}