import java.util.*;
import java.awt.*;

/**
*
* This class extends GameCanvas for processing the sprites
*
* @author C Caissotti
* @see GameCanvas
*
*/

public abstract class SpriteCanvas3 extends GameCanvas3
{
    //
    // Extends this class to draw the off screen
    //
    public Vector sprites = new Vector(50);
    public Hashtable sprdico = new Hashtable(50);
//    protected Vector tvs = new Vector(20); // Temporary vector used in onTip
    protected Sprite s; // Utilis dans l'affichage
    protected Enumeration es; // Utilis dans l'numration
    protected Enumeration esd; // Utilis dans l'numration du dessin

     //
    //
    // Sprite management
    //
    //

    public void addSprite( Sprite spr )
    {
        sprites.addElement( spr );
        sprdico.put( spr.getName(), spr );
    }


    public Sprite getSprite( String s )
    {
       Sprite spr = ( Sprite)sprdico.get(s);
       return spr;
    }

    public void removeSprite( String s )
    {
       Sprite spr = ( Sprite )sprdico.get(s);
       if ( spr != null )
       {
       sprdico.remove(s);
       sprites.removeElement(spr);
       }
    }

    public void removeSprites()
    {
        sprdico.clear();
        sprites.removeAllElements();
 //       tvs.removeAllElements();
    }


    /**
    *
    *
    * Change this function to modify the background
    *
    */

    public void drawBackOff()
    {
    }

    public void drawOff()
    {
        drawBackOff();
        esd = sprites.elements();
        while ( esd.hasMoreElements() )
        {
            s = ( Sprite )esd.nextElement();
                s.draw(gOff);
        }
    }

    //
    // Extends this class to draw the screen
    //
    protected void onTip()
    {
        onBeforeSprites();
        // First we prepare all the moves
        // So next contain the possible next point of the sprite
        // bmove is set to true.
        // Think
        // Aloww the sprite to verify if it wants to continue by setting bmove
        es = sprites.elements();
        while ( es.hasMoreElements() )
        {
            s = ( Sprite)es.nextElement();
            if ( idle % s.idle == 0 )
              {
               s.prepareMove(idle);
               s.think();
              }
        }
        // Now every sprite move
        es = sprites.elements();
        while ( es.hasMoreElements() )
        {
            s = ( Sprite)es.nextElement();
            if ( idle % s.idle == 0 )
              s.move();
        }
    }


/*    protected void onTip()
    {
        //
        // We use a close of sprites, because we don't know if a another task add a sprite
        // in the sprite list during onTip
        //
        tvs.removeAllElements();
        es = sprites.elements();
        while ( es.hasMoreElements() )
           tvs.addElement(es.nextElement());

        onBeforeSprites();
        // First we prepare all the moves
        // So next contain the possible next point of the sprite
        // bmove is set to true.
        // Think
        // Aloww the sprite to verify if it wants to continue by setting bmove
        es = tvs.elements();
        while ( es.hasMoreElements() )
        {
            s = ( Sprite)es.nextElement();
            if ( idle % s.idle == 0 )
              {
               s.prepareMove(idle);
               s.think();
              }
        }
        // Now every sprite move
        es = tvs.elements();
        while ( es.hasMoreElements() )
        {
            s = ( Sprite)es.nextElement();
            if ( idle % s.idle == 0 )
              s.move();
        }
    }

*/
    public abstract void onBeforeSprites();


}